!
! Copyright 2003-2012 Intel Corporation. All Rights Reserved.
!
! The source code contained or described herein and all documents related 
! to the source code ("Material") are owned by Intel Corporation or its 
! suppliers or licensors.  Title to the Material remains with Intel Corporation 
! or its suppliers and licensors.  The Material is protected by worldwide 
! copyright and trade secret laws and treaty provisions.  No part of the 
! Material may be used, copied, reproduced, modified, published, uploaded, 
! posted, transmitted, distributed, or disclosed in any way without Intel's 
! prior express written permission.
!
! No license under any patent, copyright, trade secret or other intellectual
! property right is granted to or conferred upon you by disclosure or delivery
! of the Materials, either expressly, by implication, inducement, estoppel 
! or otherwise.  Any license under such intellectual property rights must
! be express and approved by Intel in writing.
!
!******************************************************************************
! Content:
!   This file contains code extracted from the Fortran beginning lab instructions.
!   It is not intended as compilable code.    
!******************************************************************************! 

#define MAX 1024

subroutine loop_indep1(a, b)
  integer, dimension(MAX) :: a, b
  do j=1,MAX
    a(j) = b(j)
  end do
end subroutine loop_indep1

subroutine loop_indep2(a, b)
  integer, dimension(MAX) :: a, b
  do j=MAX, 1, -1
    a(j) = b(j)
  end do
end subroutine loop_indep2

subroutine flow_dep(A)
  real(kind=8),dimension(*)::A
  do j=2, MAX
    A(j)=A(j-1)
  end do
end subroutine flow_dep

subroutine time_stepping_loops(a,b)
  real(kind=8),dimension(*):: a, b
  do j=2, MAX
    a(j) = a(j-1) + b(j)
  end do
end subroutine time_stepping_loops

subroutine anti_dep1(A)
  real(kind=8),dimension(*):: A
  do j=1, MAX-1
    A(j)=A(j+1)
  end do
end subroutine anti_dep1

subroutine anti_dep2( A, B, C)
  real(kind=8),dimension(*):: A, B, C
  do j=1, MAX-1
    A(j)=B(j)
    A(j+1)=C(j)
  end do
end subroutine anti_dep2

subroutine reduction(sum, c)
  real(kind=8):: sum
  real(kind=8),dimension(*):: c
  do j=1, MAX
    sum = sum + c(j)
  end do
end subroutine reduction

